package my.customlibrary.dynamic;

import java.io.IOException;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.jdt.annotation.NonNull;
import org.eclipse.ocl.pivot.internal.library.StandardLibraryContribution;
import org.eclipse.ocl.pivot.internal.resource.StandaloneProjectMap;
import org.eclipse.ocl.pivot.resource.ProjectManager;
import org.eclipse.ocl.pivot.utilities.OCL;
import org.eclipse.ocl.xtext.base.cs2as.CS2AS;
import org.eclipse.ocl.xtext.base.utilities.BaseCSResource;
import org.eclipse.ocl.xtext.oclstdlib.scoping.JavaClassScope;

public class CustomLibraryContribution implements StandardLibraryContribution {
    Resource asResource;

    @Override
    public StandardLibraryContribution getContribution() {
        return this;
    }

    @Override
    @NonNull
    public Resource getResource() {
        return getDefault();
    }

    private Resource getDefault() {
        if (asResource == null) {
            try {
                asResource = doLoadASResourceFromFile();
            } catch (Exception e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
        return asResource;
    }

    private Resource doLoadASResourceFromFile() {
        OCL ocl = OCL.newInstance(OCL.CLASS_PATH);
        ResourceSet resourceSet = ocl.getResourceSet();
        getProjectMap().initializeResourceSet(resourceSet);
        URI libraryURI = URI.createPlatformPluginURI("my.customlibrary.dynamic/model/CustomLibrary.oclstdlib", true);
        BaseCSResource xtextResource = (BaseCSResource) resourceSet.createResource(libraryURI);
        JavaClassScope.getAdapter(xtextResource, getClass().getClassLoader());
        ocl.getEnvironmentFactory().adapt(xtextResource);
        try {
            xtextResource.load(null);
        } catch (IOException e) {
            e.printStackTrace();
        }
        CS2AS cs2as = xtextResource.findCS2AS();
        Resource fileResource = cs2as.getASResource();
        return fileResource;
    }

    public static @NonNull StandaloneProjectMap getProjectMap() {
        return (StandaloneProjectMap) ProjectManager.CLASS_PATH;
    }

}
